//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main(int argc, char* argv[])
{
  vector<int> coll;
  vector<int>::iterator pos;
  //    1  6   
  coll.push_back(2);
  coll.push_back(5);
  coll.push_back(4);
  coll.push_back(1);
  coll.push_back(6);
  coll.push_back(3);

  //   8    
  pos = min_element (coll.begin(),coll.end());
  cout << "min: " << *pos << endl;
  pos = max_element (coll.begin(), coll.end());
  cout << "max: " << *pos << endl;
  //   
  sort (coll.begin(), coll.end());
  cout << ToRus(" :\n");
  for (pos = coll.begin(); pos != coll.end(); ++pos) {
    cout << *pos << ' ';
  }
  //     ,  3
  pos = find (coll.begin(), coll.end(), // 
        3); // 
  //      3
  //       
  reverse (pos, coll.end());

  //   
  cout << ToRus("\n  :\n");
  for (pos = coll.begin(); pos != coll.end(); ++pos) {
    cout << *pos << ' ';
  }

  getch();
  return 0;
}
//---------------------------------------------------------------------------
